<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: Gaussian process</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('gp.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">Gaussian process</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="gp-training"></a>
Training</h1>
<p>MeLOn supports two options for training Gaussian processes:</p><ul>
<li>Using python with the</li>
<li>Using Matlab with the provided training framework</li>
</ul>
<p>It is recommended that you rely on the provided example scripts for training your model. The reason for this is that MeLOn doesn't support all functionality included in gpytorch and by using the examples you can assure to generate models which are compatible with the MeLOn functionalities.</p>
<h2><a class="anchor" id="gp-python"></a>
Python</h2>
<h3><a class="anchor" id="gp-python-training-requirements"></a>
Requirements</h3>
<ul>
<li>Python (&gt;=3.6)</li>
<li>gpytorch (&gt;=1.3.1)</li>
<li>scikit-learn (&gt;=0.23.2)</li>
<li>numpy (&gt;=1.19.4)</li>
<li>pyDOE (&gt;=0.3.8)</li>
</ul>
<h3><a class="anchor" id="gp-training-python-examples"></a>
Using the example scripts</h3>
<p>There are two python example scripts provided that show how to train a gaussian process using gpytorch. The difference between the scripts is how the trained model is handled.</p><ul>
<li>The script <code>example_training_gp_pymelon.py</code> creates a MeLOn GPData object and directly starts to solve an optimization problem which includes the model by making use of the MAiNGO and MeLOn python interfaces (pymaingo and pymelon).</li>
<li>The script <code>example_training_gp.py</code> creates a json file that can be parsed by the C++ version of MeLOn (e.g. required for the parallelized solution of an optimization problem as using MPI is not yet supported by pymaingo).</li>
</ul>
<p>The training data used for the examples is generated within the scripts themselves (see sections "SET PARAMETERS" and "GENERATE DATA"), but you can also load your data from files using a preferred method. In addition to the parameters for generating/loading your data you have to set the following parameters according to your needs:</p><ul>
<li>Kernel parameter <code>MATERN</code>: Value of the matern kernel parameter nu<ul>
<li>1: nu = 1/2</li>
<li>3: nu = 3/2</li>
<li>5: nu = 5/2</li>
</ul>
</li>
<li>Number of training iterations <code>N_TRAINING_ITER</code></li>
</ul>
<p>For generating a GPData object that can be used with the pymelon and pymaingo interfaces use the function <code>generate_melon_gp_object</code>. For saving the model to a json file that can be used by the MeLOn C++ version use the function <code>save_model_to_json</code>.</p>
<h2><a class="anchor" id="gp-matlab"></a>
Matlab</h2>
<p>The training script gives you an example of how to train a Gaussian process in Matlab. In the provided example the training data is generated within the script, but you can also load the data using your preferred method. In addition to the training data you also have to provide the lower and upper bounds of the input variables you use for training, these are used for a min-max feature scaling. Further, you can specify the following training options:</p><ul>
<li>Kernel parameter (<code>Opt.GP(1).matern</code>): Value of the matern kernel parameter nu<ul>
<li>1: nu = 1/2</li>
<li>3: nu = 3/2</li>
<li>5: nu = 5/2</li>
<li>inf: nu = infinity</li>
</ul>
</li>
<li>Stopping criterium for internal solver (<code>Opt.GP(1).fun_eval</code>): Number of function evaluations for each hyperparameter.</li>
</ul>
<p>To train and save the model you have to use the functions <code>Train_GP_and_return_hyperparameters</code> and <code>Write_GP_to_json</code> respectively.</p>
<h1><a class="anchor" id="gp-usage"></a>
Usage</h1>
<p>To include the trained model in your MAiNGO problem formulation you can either use the MeLOn C++ or the pymaingo and pymelon python interface. An example of how to include a Gaussian process in your optimization problem can be found in the MAiNGO folder.</p>
<h2><a class="anchor" id="gp-usage-constructors"></a>
Constructors</h2>
<ul>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a386be5795c1407b0df246c12b8035054" title="Default Constructor.">melon::GaussianProcess&lt;T&gt;::GaussianProcess()</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#ae1c32e218afd15ba63535b145d9856e8" title="Constructor.">melon::GaussianProcess&lt;T&gt;::GaussianProcess(std::string modelName)</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#ad022caec3e9f32a89a554afa9ea77883" title="Constructor.">melon::GaussianProcess&lt;T&gt;::GaussianProcess(std::string modelPath, std::string modelName)</a></li>
<li>melon::GaussianProcess&lt;T&gt;::GaussianProcess(std::shared_ptr&lt;const GPData&gt; modelData)</li>
</ul>
<h2><a class="anchor" id="gp-usage-prediction"></a>
Prediction and variance</h2>
<ul>
<li>melon::GaussianProcess&lt;T&gt;::calculate_prediction_reduced_space(std::vector&lt;T&gt; input)</li>
<li>melon::GaussianProcess&lt;T&gt;::calculate_variance_reduced_space(std::vector&lt;T&gt; input)</li>
<li>melon::GaussianProcess&lt;T&gt;::calculate_prediction_full_space(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</li>
<li>melon::GaussianProcess&lt;T&gt;::calculate_variance_full_space(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</li>
<li>melon::GaussianProcess&lt;T&gt;::calculate_prediction_and_variance_full_space(std::vector&lt;T&gt; input, std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints)</li>
</ul>
<h2><a class="anchor" id="gp-usage-internal-variables"></a>
Internal variables</h2>
<ul>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#ae4ee37192b3384763b4e43c8c3d345ee" title="Get the number of internal variables used in the calculation of the prediction.">melon::GaussianProcess&lt;T&gt;::get_number_of_full_space_variables_prediction()</a></li>
<li>melon::GaussianProcess&lt;T&gt;::get_full_space_variables_prediction(unsigned int&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds)</li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#aa57f8f0996f1a8f467d4e0a4460daccc" title="Get the number of internal variables used in the calculation of the variance.">melon::GaussianProcess&lt;T&gt;::get_number_of_full_space_variables_variance()</a>;</li>
<li>melon::GaussianProcess&lt;T&gt;::get_full_space_variables_variance(unsigned int&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds)</li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a585d1d461394871c97aad401c2228c99" title="Get the number of internal variables used in the calculation of prediction and variance.">melon::GaussianProcess&lt;T&gt;::get_number_of_full_space_variables_prediction_and_variance()</a></li>
<li>melon::GaussianProcess&lt;T&gt;::get_full_space_variables_prediction_and_variance(unsigned int&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds);</li>
</ul>
<h2><a class="anchor" id="gp-usage-training-data"></a>
Information on training data</h2>
<ul>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a006eeec94356a5c0d487afe48576c5da" title="Get the dimesnion of the input.">melon::GaussianProcess&lt;T&gt;::get_input_dimension()</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a99abab766cd09603c980597d38116d53" title="Get the number of training data points.">melon::GaussianProcess&lt;T&gt;::get_number_of_training_data_points()</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a0e3d14f20ee559d8cf964ebf36bc386b" title="Get the minimum value of the training data outputs.">melon::GaussianProcess&lt;T&gt;::get_minimum_of_training_data_outputs()</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a35581bbd6af8440edc7a1b61215a005b" title="Get the maximum value of the training data outputs.">melon::GaussianProcess&lt;T&gt;::get_maximum_of_training_data_outputs()</a></li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#ac30f580feffc439827c21b45186306b7" title="Get the observations based on which the Gaussian process was trained and is evaluated.">melon::GaussianProcess&lt;T&gt;::get_observations()</a>;</li>
<li><a class="el" href="classmelon_1_1_gaussian_process.html#a88731473ec79c91e7d76b73f445abca5" title="Returns the the normalized values of the observations based on which the Gaussian process was trained...">melon::GaussianProcess&lt;T&gt;::get_normalized_observations()</a> </li>
</ul>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="index.html">MeLOn - Machine Learning models for Optimization</a></li><li class="navelem"><a class="el" href="models.html">Models</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
